import java.io.*;
import java.net.*;

public class WebSocketServer
{
  // Sample method to encode a binary file into a Base64 string.
  // Author: Christian d'Heureuse (www.source-code.biz)
  private static String encodeFile (String inputFileName) throws IOException
  {
    BufferedInputStream in = null;
    StringBuffer ret = new StringBuffer();
    try
    {
      in = new BufferedInputStream(new FileInputStream(inputFileName));
      int lineLength = 76;
      byte[] buf = new byte[lineLength/4*3];
      while (true) {
        int len = in.read(buf);
        if (len <= 0)
          break;
        ret.append(Base64Coder.encode(buf,len));
        ret.append("\r\n");
      }

      return ret.toString();
    }
    finally
    {
      if (in != null)
        in.close();
    }
  }

  public static void main(String args[]) throws Exception
  {
    ServerSocket ss = new ServerSocket(81);

    Socket s = ss.accept();

    DataInputStream is = new DataInputStream(s.getInputStream());
    DataOutputStream os = new DataOutputStream(s.getOutputStream());
    //FileOutputStream fos = new FileOutputStream("/tmp/saida-websocket.txt");

    try
    {
      byte[] last4chars = new byte[4];
      last4chars[0] = 0;last4chars[1] = 0;last4chars[2] = 0;last4chars[3] = 0;

      //System.out.println("reading request");
      while (last4chars[0] != 0x0d || last4chars[1] != 0x0a ||
             last4chars[2] != 0x0d || last4chars[3] != 0x0a) {
        byte lido = is.readByte();
        //fos.write((int)lido);
        last4chars[0] = last4chars[1];
        last4chars[1] = last4chars[2];
        last4chars[2] = last4chars[3];
        last4chars[3] = lido;
      }
      //System.out.println("request accepted");

      os.writeBytes("HTTP/1.1 101 Web Socket Protocol Handshake\r\n");
      os.writeBytes("Upgrade: WebSocket\r\n");
      os.writeBytes("Connection: Upgrade\r\n");
      os.writeBytes("websocket-origin: file://\r\n");
      os.writeBytes("websocket-location: ws://127.0.0.1/superXiao\r\n");
      os.writeBytes("\r");

      os.writeByte(0xff);os.writeByte(0x05);os.writeBytes("xxxxx");  //some bad data..
      os.writeByte(0x0f);os.writeBytes("xxxxx");os.writeByte(0xff);  //some bad data..

      int currentFrame = 1;
      String pedido = "";
      while (pedido.compareTo("close") != 0) {
        byte[] bytes = new byte[100];
        byte lido;
        int numBytes;

        lido = 0;
        numBytes = 0;

        while (lido != -1) {
          lido = is.readByte();
          //System.out.print(lido + " ");
          //fos.write((int)lido);
          if (lido != 0x00 && lido != -1) {
            if (numBytes == bytes.length) {
              //System.out.println("error reading message");
              throw new Exception("fix me..");
            }
            bytes[numBytes++] = lido;
          }
        }
        //System.out.println();

        pedido = new String(bytes, 0, numBytes, "UTF-8");
        //System.out.println("pedido: "+pedido);
        if (pedido.compareTo("next") == 0 && currentFrame <= 5346) {
          //System.out.println("sending frame: "+currentFrame);
          //System.out.println("file: "+"./xiaoxiao/video" + currentFrame + ".jpg");
          byte[] utf8 = encodeFile("./xiaoxiao/video" + currentFrame + ".jpg").getBytes("UTF-8");
          os.writeByte(0x00);os.write(utf8, 0, utf8.length);os.writeByte(0xff);
          currentFrame++;
        }
      }

    } catch (EOFException e) {
      ;
    }

    //fos.close();
    os.close();
    is.close();
    s.close();
    ss.close();
  }
}
